from django.shortcuts import render,redirect
from rest_framework.response import Response
from rest_framework import status
from rest_framework.views import APIView
from django.contrib.auth.decorators import user_passes_test
from django.utils.decorators import method_decorator
from django.db.models import Count
import json
#from clauthApp.models import BranchDoctor, BranchReception
#from clmainApp.serializers import BranchDoctorsSerializer, BranchReceptionsSerializer
from clmainApp.models import *
from clmainApp.serializers import *
from clbranchApp.models import *
from clmainApp.utils import getDayName
from clmainApp.utils import getClinicId,getBranchId
from .serializers import *
from django.apps import apps
from django.forms.models import model_to_dict

class AddObjectByNameApi(APIView):
    #@method_decorator(user_passes_test(lambda u: u.has_perm('screen.PrintReport'), login_url='/main/login/'))
    def post(self,request):
        branchId = getBranchId(request)
        if not branchId : return Response(status=status.HTTP_400_BAD_REQUEST)
        data = request.data
        if "modelName" in data and "objectName" in data  :
            try : 
                field_name_to_check = "created_by"
                model = apps.get_model(data["modelName"])
                if field_name_to_check in [field.name for field in model._meta.get_fields()]:
                    newObj = model.objects.create(name=data["objectName"],branch_id=branchId,created_by=request.user)
                else : newObj = model.objects.create(name=data["objectName"],branch_id=branchId)
                return Response(model_to_dict(newObj),status=status.HTTP_201_CREATED)
            except: return Response(status=status.HTTP_400_BAD_REQUEST)
        else : return Response(status=status.HTTP_400_BAD_REQUEST)


class WelcomeApi(APIView):
    #@method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.view_nationality'), login_url='/auth/login/'))
    def get(self,request,branch_id):
        #if not getClinicId(request) : return redirect('/main/login/')
        #check if user has permissions to access this page and add any session variables in this function 
        # or add it in login function 
        #if request.user.user_category == "1OTHR" :#"مستخدم عام"
        #if request.user.user_category == "2DR" :#"طبيب"
        # if request.user.user_category == "3RCP" :#"موظف إستقبال" / سكرتارية - محاسب 
        #     #https://stackoverflow.com/questions/27330543/how-to-redirect-with-variables-in-django
        #     #return redirect('rcpmainApp:ReceptionBranchesApi',{'clinic_id':clinic_id}) # Not Working
        #     return redirect('rcpmainApp:ReceptionBranchesApi',clinic_id)
        try :
            branch = Branch.objects.get(id=branch_id)
            request.session['branchName'] = branch.name
            request.session['branchId'] = branch.id
            request.session['welcomeImg'] = branch.welcome_img.url
            request.session['iconImg'] = branch.icon_img.url
            request.session['reportsCode'] = branch.reports_code
            if 'clinicName' in request.session: del request.session['clinicName']
            if 'clinicId' in request.session: del request.session['clinicId']
            if request.user.is_superuser :
                #user_groups_categories = Group.objects.filter(group_type="BR").values_list('group_category',flat=True).annotate(Count('group_category',distinct=True))
                return render(request,'Branch/branch_welcome.html')
            else :
                user_groups_categories = request.user.groups.filter(group_type="BR").values_list('group_category',flat=True).annotate(Count('group_category',distinct=True))
                if not user_groups_categories : redirect('clauthApp:home')
                if "1MNGMNT" in user_groups_categories :#مستخدم عام هيشوف صفحات الإدارة 
                    return render(request,'Branch/branch_welcome.html')
                elif "3RCP" in user_groups_categories :
                    return redirect('rcpmainApp:WelcomeApi',branch_id)
                else :return redirect('clauthApp:home')
        except Exception as err_msg: 
            #print("{}".format(str(err_msg)))
            if 'clinicName' in request.session: del request.session['clinicName']
            if 'clinicId' in request.session: del request.session['clinicId']
            if 'branchName' in request.session: del request.session['branchName']
            if 'branchId' in request.session: del request.session['branchId']
            if 'welcomeImg' in request.session: del request.session['welcomeImg']
            if 'iconImg' in request.session: del request.session['iconImg']
            if 'reportsCode' in request.session: del request.session['reportsCode']
            return redirect('clauthApp:home')

        #return render(request,"Clinic/clmainApp/Nationality.html",{"all_nationalities":serializer.data,'activePage':'Nationalities'})

class DrWelcomeApi(APIView):
    #@method_decorator(user_passes_test(lambda u: u.has_perm('screen.view_nationality'), login_url='/auth/login/'))
    def get(self,request,branch_id):
        #if not getClinicId(request) : return redirect('/main/login/')
        #check if user has permissions to access this page and add any session variables in this function 
        # or add it in login function
        #if request.user.is_superuser : user_groups_categories = Group.objects.filter(group_type="CL").values_list('group_category',flat=True).annotate(Count('group_category',distinct=True))
        user = request.user
        user_groups_categories = user.groups.filter(group_type="CL").values_list('group_category',flat=True).annotate(Count('group_category',distinct=True))
        if "1MNGMNT" not in  user_groups_categories : redirect('clauthApp:home')
        try :
            branch = Branch.objects.get(id=branch_id)
            clinic = branch.clinic
            request.session['clinicName'] = clinic.name
            request.session['clinicId'] = clinic.id
            request.session['ClinicTypeId'] = clinic.clinic_type_id
            request.session['ClinicTypeCode'] = clinic.clinic_type.code
            request.session['branchName'] = branch.name
            request.session['branchId'] = branch_id
            request.session['welcomeImg'] = clinic.welcome_img.url
            request.session['iconImg'] = clinic.icon_img.url
            request.session['reportsCode'] = clinic.reports_code
            return render(request,'Clinic/clinic_welcome.html')
        except :
                import traceback
                traceback.print_exc()
                if 'clinicName' in request.session: del request.session['clinicName']
                if 'clinicId' in request.session: del request.session['clinicId']
                if 'clinicName' in request.session: del request.session['clinicName']
                if 'clinicId' in request.session: del request.session['clinicId']
                if 'welcomeImg' in request.session: del request.session['welcomeImg']
                if 'iconImg' in request.session: del request.session['iconImg']
                if 'reportsCode' in request.session: del request.session['reportsCode']
                return redirect('clauthApp:home')

# class DoctorBranchesApi(APIView):
#     #@method_decorator(user_passes_test(lambda u: u.has_perm('screen.view_nationality'), login_url='/auth/login/'))
#     def get(self,request,clinic_id):
#         dr_user = request.user
#         if not dr_user.user_category == "2DR" :return redirect('clauthApp:logout')
#         # #if user.is_password_reset and not user.is_active and user.is_authenticated:
#         dr_branches = BranchDoctor.objects.filter(branch__clinic_id=clinic_id,dr=dr_user).values('branch_id','branch__name','branch__clinic__name')
#         if not dr_branches : return redirect('clauthApp:logout')
#         else : return render(request,'Clinic/clmainApp/available_branches.html',{"dr_branches":dr_branches})


class BranchesApi(APIView):
    @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.view_branches'), login_url='/auth/login/'))
    def get(self,request):
        #if not getClinicId(request) : return redirect('/main/login/')
        clinicId = getClinicId(request)
        if not clinicId : return redirect('clauthApp:home')
        clinic = Clinic.objects.get(id=clinicId)
        all_doctors = User.objects.all().filter(user_category = "2DR")
        #all_receptions = User.objects.all().filter(user_category = "3RCP")
        #عشان لو عايز حد من المديرين يشوف شاشات الاستقبال
        all_receptions = User.objects.all().filter(user_category__in = ["1OTHR","3RCP"])
        clinic_branches =Branch.objects.filter(clinic_id=clinicId)
        locations = Location.objects.all()
        return render(request,"Clinic/clmainApp/branches.html",{
            "clinic_branches":clinic_branches,
            "locations":locations,
            "all_doctors": all_doctors,
            "all_receptions": all_receptions,
            "clinic":clinic,
            'activePage':'Branches'})


class BranchApi(APIView):
    def get_object(self,pk):
        try:
            return Branch.objects.get(pk=pk)
        except Branch.DoesNotExist:
            return None    
        
    #@method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.view_Doctor'), login_url='/main/login/'))        
    def post(self,request,pk): 
        branch=self.get_object(pk)
        data = request.data
        days_data_json = data['days_data'] 
        days_data = json.loads(days_data_json)
        if days_data : 
            branch_days_objs  = BranchDay.objects.filter(branch=branch)
            branch_days_ids = branch_days_objs.values_list('id',flat=True)
            dds = BranchDaySlot.objects.filter(branch_day__in = branch_days_ids)
            dds.delete()
            branch_days_objs.delete()
            for obj in days_data :
                branchDay = BranchDay.objects.create(branch=branch,day_id=obj["day"])
                for slot_id in obj["slots"]:
                    BranchDaySlot.objects.create(branch_day=branchDay,slot_id=slot_id)
        return Response(status=status.HTTP_200_OK)
def findInListOfDict(arr , slot_id):
    for x in arr:
        if int(x["slot_id"]) == slot_id:
            return x
        else : continue
# class TempDaySlotsApi(APIView):
#     @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.change_fixedworktimes_branches'), login_url='/auth/login/'))
#     def get(self,request,day_id): 
#         branchDaysSlots = TempBranchDaySlot.objects.filter(branch_day_id =day_id).values('slot_id','max_pt')
#         slots_data = []
#         for slot in branchDaysSlots:
#             slot_data = {"slot_id":slot["slot_id"],"max_pt":slot["max_pt"]}
#             slots_data.append(slot_data)
#         return Response(slots_data,status=status.HTTP_200_OK)


class ActiveHourSlotsApi(APIView):
    @method_decorator(user_passes_test(lambda u: u.has_perm('ClManagement.change_fixedworktimes_branches'), login_url='/auth/login/'))
    def get(self,request,branch_id): 
        #weekDays = WeekDay.objects.filter(is_active=True).order_by('order').values()
        hourSlots = ActiveHourSlot.objects.filter(branch=branch_id).values_list('hour_slot_id',flat=True)
        return Response(list(hourSlots),status=status.HTTP_200_OK)
    @method_decorator(user_passes_test(lambda u: u.has_perm('ClManagement.change_fixedworktimes_branches'), login_url='/auth/login/'))        
    def post(self,request,branch_id):
        data = request.data
        branch_active_slots = data.getlist('branch_slots[]')
        tbd_slots=[]
        for slot_id in branch_active_slots:
            tbd_slots.append(ActiveHourSlot(branch_id=branch_id,hour_slot_id=slot_id))
        try :
            ActiveHourSlot.objects.filter(branch_id=branch_id).delete()
            ActiveHourSlot.objects.bulk_create(tbd_slots)
            return Response(status=status.HTTP_201_CREATED)
        except Exception as err_msg: 
            return Response(data =" حدث خطأ إضافة توقيتات الفرع \n {}".format(str(err_msg)),status=status.HTTP_400_BAD_REQUEST) 

#ايام العمل للاطباء
class BranchDoctorDaysApi(APIView):
    @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.view_BranchDoctorDays'), login_url='/auth/login/'))
    def get(self,request):
        branchId = getBranchId(request)
        if not branchId : return redirect('clauthApp:home')
        #branch_doctors = User.objects.filter(user_category="2DR",groups__branch_id=branchId,is_active=True).values("id","name")
        branch_doctors = DrData.objects.filter(branch_id=branchId,dr__is_active=True).values("id","dr_id","dr__name","dr_level_id","dr_level__name","month_salary")
        weekDays = WeekDay.objects.filter(is_active=True).order_by('order').values()
        return render(request,"Branch/brmainApp/branch_doctors_days.html",{"branch_doctors":branch_doctors,"weekDays":weekDays,
            'activePage':'BranchDoctorDays'})

#بيانات الأطباء
class DoctorsDataApi(APIView):
    @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.view_DoctorsData'), login_url='/auth/login/'))
    def get(self,request):
        branchId = getBranchId(request)
        if not branchId : return redirect('clauthApp:home')
        #branch_doctors = User.objects.filter(user_category="2DR",groups__branch_id=branchId,is_active=True).values("id","name")
        dr_levels = DrLevel.objects.filter(branch_id=branchId).values('id',"name","session_price")
        branch_doctors = DrData.objects.filter(branch_id=branchId,dr__is_active=True,is_active=True).values("id","dr_id","dr__name","dr_level_id","dr_level__name","month_salary","salary_phone_number")
        weekDays = WeekDay.objects.filter(is_active=True).order_by('order').values()
        return render(request,"Branch/brmainApp/branch_doctors_data.html",
                      {"branch_doctors":branch_doctors,"weekDays":weekDays,"dr_levels":dr_levels,
                        'activePage':'BranchDoctorsData'})
    
class DoctorWorkingDaysApi(APIView):
    @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.view_BranchDoctorDays'), login_url='/auth/login/'))
    def get(self,request,doctor_id):
        branchId = getBranchId(request)
        if not branchId : return Response(status=status.HTTP_400_BAD_REQUEST)
        #weekDays = WeekDay.objects.filter(is_active=True).order_by('order').values()
        dr_working_days = DrWorkingDay.objects.filter(dr_id=doctor_id,branch_id=branchId).values_list('weekday_id',flat=True)
        return Response(list(dr_working_days),status=status.HTTP_200_OK)
    
    @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.view_BranchDoctorDays'), login_url='/auth/login/'))
    def post(self,request,doctor_id):
        branchId = getBranchId(request)
        if not branchId : return Response(status=status.HTTP_400_BAD_REQUEST)
        data = request.data
        working_days = data.getlist('working_days[]')
        dr_working_days_objs=[]
        for weekday_id in working_days:
            dr_working_days_objs.append(DrWorkingDay(branch_id=branchId,dr_id=doctor_id,weekday_id=weekday_id))
        try :
            DrWorkingDay.objects.filter(branch_id=branchId,dr_id=doctor_id).delete()
            DrWorkingDay.objects.bulk_create(dr_working_days_objs)
            return Response(status=status.HTTP_201_CREATED)
        except Exception as err_msg: 
            return Response(data =" حدث خطأ إضافة أيام عمل الطبيب  \n {}".format(str(err_msg)),status=status.HTTP_400_BAD_REQUEST) 
    
    # @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.change_fixedworktimes_branches'), login_url='/auth/login/'))        
    # def put(self,request,branch_id):
    #     data = request.data
    #     slots_data_json = data['slots_data']
    #     slots_data = json.loads(slots_data_json)
    #     #slots_data = [{"slot_id":34,"max_pt":14},{"slot_id":35,"max_pt":15},{"slot_id":36,"max_pt":16}]
    #     slots_ids = [obj["slot_id"] for obj in slots_data]
    #     slots_db = BranchDaySlot.objects.filter(id__in=slots_ids)
    #     for s_db in slots_db:
    #         slot_data = findInListOfDict(slots_data , s_db.id)
    #         s_db.max_pt = slot_data["max_pt"]
    #     BranchDaySlot.objects.bulk_update(slots_db, ["max_pt"])
    #     return Response(status=status.HTTP_201_CREATED)

from clhrApp.models import *
from datetime import timedelta,datetime
from django.db.models import Sum

class DoctorDataApi(APIView):
    def get_object(self,pk):
        try:
            return DrData.objects.get(pk=pk)
        except DrData.DoesNotExist:
            return None   
        
    @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.view_DrData'), login_url='/auth/login/'))
    def get(self,request,dr_data_id):
        branchId = getBranchId(request)
        if not branchId : return Response(status=status.HTTP_400_BAD_REQUEST)
        dr_data_obj=self.get_object(dr_data_id)
        if dr_data_obj :
            context = {"dr_data_obj":dr_data_obj,'activePage':'BranchDoctorsData'}
            all_earnings = Earning.objects.all()
            all_deductions = Deduction.objects.all()
            context.update({"all_earnings":all_earnings,"all_deductions": all_deductions})
            drSalaries = DrSalary.objects.filter(dr_data_id=dr_data_id).order_by('-to_day')
            not_paid_salary = drSalaries.filter(pay_day__isnull=True).count()
            max_pay_day = drSalaries.aggregate(Max('pay_day'))['pay_day__max']
            max_pay_dayObjs = drSalaries.filter(pay_day = max_pay_day)
            if max_pay_dayObjs : 
                last_to_day = max_pay_dayObjs[0].to_day
                day_after_last_to_day = last_to_day+timedelta(days=1)
            else : day_after_last_to_day = None
            context.update({
            "all_dr_salaries":drSalaries ,
             'day_after_last_to_day':day_after_last_to_day,
             'dr_payday_max':drSalaries.aggregate(Max('pay_day'))['pay_day__max'],
             "not_paid_salary":not_paid_salary})
            drEarnings = DrEarning.objects.filter(dr_data_id=dr_data_id ,is_done=False).order_by('-created_at')
            context.update({"all_dr_earnings":drEarnings , 'dr_earnings_sum':drEarnings.aggregate(Sum('amount'))['amount__sum']})
            drDeduction = DrDeduction.objects.filter(dr_data_id=dr_data_id, is_done=False).order_by('-created_at')
            context.update({"all_dr_deductions":drDeduction , 'dr_deductions_sum':drDeduction.aggregate(Sum('amount'))['amount__sum']})
            # patientVisitObjs = PatientVisit.objects.filter(patient=patientObj,visit_status__in=["1I","4F"]).order_by('-visit_day')
            # patientVisitObjs_serialized = PatientVisitMiniSerializer(patientVisitObjs,many=True)
            # context.update({'patientVisitObjs':patientVisitObjs_serialized.data})
            # medical_services =MedicalService.objects.all().values('id', 'name','price')
            # context.update({"medical_services":medical_services,})           
            # blood_type_choices = ChoiceField(choices=BLOOD_TYPE_CHOICES)
            # context.update({"blood_types":blood_type_choices.choices,})
            # context.update({"pageTitle":patientObj.fullname,})
            return render(request,"Branch/brmainApp/doctor_data.html",context)
        else : return redirect('/main/login/')
    
    @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.change_DrData'), login_url='/auth/login/'))
    def put(self,request,dr_data_id):
        obj=self.get_object(dr_data_id)
        data = request.data
        data._mutable = True
        data.update({"created_by":request.user.id})
        serializedObj= DrDataSerializer(obj,data=data,partial=True)
        #serializedObj= MedicalServiceSerializer(obj,data=request.data,partial=True)
        if serializedObj.is_valid():
            serializedObj.save()
            return Response(status=status.HTTP_200_OK)
        else : return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)

##### dr_earnings  استحقاق لموظف او مكافأة أو مرتب ########

class DrEarningsApi(APIView):
    #next step مش هعرض في الصفحة علي طول هعمل loading ومتظهرش إلا لما يضغط عليها 
    #@method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.view_Exercise'), login_url='/main/login/'))
    def get(self,request,dr_data_id):
        branchId = getBranchId(request)
        if not branchId : return redirect('clauthApp:home')
        dr_ern =DrEarning.objects.all() #,is_done=False
        dr_ern_srl=DrEarningSerializer(dr_ern,many=True)
        return render(request,"clhrApp/Managment/exercises.html",{"dr_ern":dr_ern_srl.data,
        'activePage':'DrEarnings'})

    #@method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.add_DrEarning'), login_url='/main/login/'))    
    def post(self,request,dr_data_id):
        branchId = getBranchId(request)
        if not branchId : return redirect('clauthApp:home')
        request.data._mutable = True
        request.data.update({"dr_data":dr_data_id})
        request.data.update({"earning_note":None if (not request.data["earning_note"]) else request.data["earning_note"] })       
        request.data.update({"is_done":False})       
        request.data.update({"created_by":request.user.id})
        serializedObj= DrEarningSerializer(data=request.data)
        if serializedObj.is_valid():
            serializedObj.save()
            return Response(serializedObj.data,status=status.HTTP_201_CREATED)
        else :return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)

class DrEarningApi(APIView):
    def get_object(self,pk):
        try:
            return DrEarning.objects.get(pk=pk)
        except DrEarning.DoesNotExist:
            return None    
    
    # @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.view_DrEarning'), login_url='/main/login/'))        
    # def get(self,request,pk): 
    #     exrszObj=self.get_object(pk)
    #     if exrszObj :
    #         serializeobj= DrEarningSerializer(exrszObj)
    #         return Response(serializeobj.data,status=status.HTTP_200_OK)
    #     else : return Response(status=status.HTTP_404_NOT_FOUND)

    # @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.edit_DrEarning'), login_url='/main/login/'))
    # def put(self,request,pk):
    #     obj=self.get_object(pk)
    #     serializedObj= DrEarningSerializer(obj,data=request.data)
    #     if serializedObj.is_valid():
    #         serializedObj.save()
    #         return Response(status=status.HTTP_200_OK)
    #     else : return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)

    #@method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.delete_DrEarning'), login_url='/main/login/'))
    def delete(self,request,pk):
        obj=self.get_object(pk)
        if obj :
            try:
                obj.delete()
                return Response(status=status.HTTP_204_NO_CONTENT)
            except Exception as err_msg: 
                    return Response(data ="{}".format(str(err_msg)),status=status.HTTP_405_METHOD_NOT_ALLOWED)
        else : return Response("Object Deleted By another User !! Reload Your page ..", status=status.HTTP_404_NOT_FOUND)



#https://stackoverflow.com/questions/29858701/django-query-isnull-true-or-none
# حساب القيمة المبدئية للراتب من بيانات الحضور والإنصراف والعلاوات والخصومات
class DrSalaryDataApi(APIView):
    #@method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.view_MedServiceReportDoctor'), login_url='/main/login/'))
    def get(self,request,dr_data_id):
        branchId = getBranchId(request)
        if not branchId : return redirect('clauthApp:home')
        medical_services = MedicalService.objects.all().values("id","name")
        departments=  Department.objects.all().order_by("d_order")
        doctors =Doctor.objects.filter(is_active=True).values("id","name","department")
        return render(request,"mainApp/financePages/med_service/doctor.html",{
        "medical_services":medical_services,"doctors":doctors,
        "departments":departments,'activePage':'MedServiceReportDoctor'})
    #@method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.view_MedServiceReportDoctor'), login_url='/main/login/'))    
    def post(self,request,dr_data_id):
            branchId = getBranchId(request)
            if not branchId : return redirect('clauthApp:home')
            data=request.data
            startDate =  datetime.strptime(data["startDate"], '%Y-%m-%d') 
            endDate =datetime.strptime(data["endDate"], '%Y-%m-%d') .replace(hour=23,minute=59,second=59,microsecond=59)
            #attendace_data = DrAttendance.objects.filter(dr_id =dr_id,check_out_by__isnull=False,day__gte = startDate, day__lte=endDate,is_done=False,salary__isnull=True).order_by("day")
            total_drEarning = DrEarning.objects.filter(dr_data_id =dr_data_id,created_at__gte = startDate, created_at__lte=endDate,is_done=False,salary__isnull=True).aggregate(Sum('amount'))['amount__sum']
            total_drDeduction = DrDeduction.objects.filter(dr_data_id =dr_data_id,created_at__gte = startDate, created_at__lte=endDate,is_done=False,salary__isnull=True).aggregate(Sum('amount'))['amount__sum']

            #else : 
                #visits = PatientVisit.objects.filter(created_at__gte = startDateTime , created_at__lte=endDateTime,doctor_id=doctor,medicalservice_id=medicalservice,visit_status="4F").order_by("created_at")
            #attendace_serializer= DrAttendanceSerializer(attendace_data,many=True)
            return Response({
                #"attendace_data":attendace_serializer.data,
            "total_drEarning":total_drEarning,"total_drDeduction":total_drDeduction},
            status=status.HTTP_200_OK)

class DrSalaryApi(APIView):
    def get_object(self,pk):
        try:
            return DrSalary.objects.get(pk=pk)
        except DrSalary.DoesNotExist:
            return None   
    #@method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.add_DrEarning'), login_url='/main/login/'))    
    def post(self,request,dr_data_id):
        branchId = getBranchId(request)
        if not branchId : return redirect('clauthApp:home')
        request.data._mutable = True
        request.data.update({"dr_data":dr_data_id})    
        request.data.update({"created_by":request.user.id})
        data=request.data
        #startDate = data["from_day"]
        #endDate = data["to_day"]
        att__ids = data.getlist('att__ids[]')
        ee__ids = data.getlist('ee__ids[]')
        ed__ids = data.getlist('ed__ids[]')
        serializedObj= DrSalarySerializer(data=data)
        if serializedObj.is_valid():
            serializedObj.save()
            salary_id = serializedObj.data["id"]
            #DrAttendance.objects.filter(id__in=att__ids).update(salary_id=salary_id,is_done=True)
            DrEarning.objects.filter(id__in=ee__ids).update(salary_id=salary_id,is_done=True)
            DrDeduction.objects.filter(id__in=ed__ids).update(salary_id=salary_id,is_done=True)
            return Response(serializedObj.data,status=status.HTTP_201_CREATED)
        else :return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)
    
    #@method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.edit_Job'), login_url='/main/login/'))
    def put(self,request,dr_data_id):
        request.data._mutable = True
        request.data.update({"pay_day":timezone.now().date()})    
        request.data.update({"delivered_by":request.user.id})
        data=request.data
        salaryId = data["dr_salary_id"]
        obj=self.get_object(salaryId)
        serializedObj= DrSalarySerializer(obj,data=data,partial=True)
        #list_error=""
        if serializedObj.is_valid():
            serializedObj.save()
            return Response(status=status.HTTP_200_OK)
        else : return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)
    #@method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.delete_DrDeduction'), login_url='/main/login/'))
    def delete(self,request,dr_data_id):
        data=request.data
        salaryId = data["dr_salary_id"]
        dr_salary=self.get_object(salaryId)
        #DrAttendance.objects.filter(salary_id=salaryId).update(salary=None,is_done=False)
        DrEarning.objects.filter(salary_id=salaryId).update(salary=None,is_done=False)
        DrDeduction.objects.filter(salary_id=salaryId).update(salary=None,is_done=False)
        if dr_salary :
            try:
                dr_salary.delete()
                return Response(status=status.HTTP_204_NO_CONTENT)
            except Exception as err_msg: 
                    return Response(data ="{}".format(str(err_msg)),status=status.HTTP_405_METHOD_NOT_ALLOWED)
        else : return Response(status=status.HTTP_404_NOT_FOUND)

##### dr_deductions  خصم لموظف########
class DrDeductionsApi(APIView):
    #@method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.add_DrDeduction'), login_url='/main/login/'))    
    def post(self,request,dr_data_id):
        branchId = getBranchId(request)
        if not branchId : return redirect('clauthApp:home')
        request.data._mutable = True
        request.data.update({"dr_data":dr_data_id})
        request.data.update({"deduction_note":None if (not request.data["deduction_note"]) else request.data["deduction_note"] })       
        request.data.update({"is_done":False})       
        request.data.update({"created_by":request.user.id})
        serializedObj= DrDeductionSerializer(data=request.data)
        if serializedObj.is_valid():
            serializedObj.save()
            return Response(serializedObj.data,status=status.HTTP_201_CREATED)
        else :return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)

class DrDeductionApi(APIView):
    def get_object(self,pk):
        try:
            return DrDeduction.objects.get(pk=pk)
        except DrDeduction.DoesNotExist:
            return None   
    #@method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.delete_DrDeduction'), login_url='/main/login/'))
    def delete(self,request,pk):
        obj=self.get_object(pk)
        if obj :
            try:
                obj.delete()
                return Response(status=status.HTTP_204_NO_CONTENT)
            except Exception as err_msg: 
                    return Response(data ="{}".format(str(err_msg)),status=status.HTTP_405_METHOD_NOT_ALLOWED)
        else : return Response(status=status.HTTP_404_NOT_FOUND)



class DrEarningsDataApi(APIView):
    #@method_decorator(user_passes_test(lambda u: u.has_perm('screen.view_canceled_visits_cc_report'), login_url='/main/login/'))
    def post(self,request):
        data = request.data
        dr_earnings_ids = data.getlist('salary_details[]')
        if '' in  dr_earnings_ids : dr_earnings_ids.pop(dr_earnings_ids.index(''))
        dr_earnings = DrEarning.objects.filter(id__in=dr_earnings_ids)
        dr_earnings_data = DrEarningSerializer(dr_earnings,many=True).data
        return Response(dr_earnings_data , status=status.HTTP_200_OK)

class DrDeductionsDataApi(APIView):
    #@method_decorator(user_passes_test(lambda u: u.has_perm('screen.view_canceled_visits_cc_report'), login_url='/main/login/'))
    def post(self,request):
        data = request.data
        dr_deductions_ids = data.getlist('salary_details[]')
        if '' in  dr_deductions_ids : dr_deductions_ids.pop(dr_deductions_ids.index(''))
        dr_deductions = DrDeduction.objects.filter(id__in=dr_deductions_ids)
        dr_deductions_data = DrDeductionSerializer(dr_deductions,many=True).data
        return Response(dr_deductions_data , status=status.HTTP_200_OK)



# class BranchTempScheduleApi(APIView):
#     @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.change_fixedworktimes_branches'), login_url='/auth/login/'))
#     def get(self,request,branch_id): 
#         #branch=self.get_object(branch_id)
#         #if not branch : return redirect('clauthApp:home')
#         hourSlots = HourSlot.objects.filter(is_active=True).values('id','name').order_by('order')
#         timezone_now_today = timezone.now().date()
#         branchDays = TempBranchDay.objects.filter(branch_id = branch_id,day__gte=timezone_now_today).values('id','day','notes','is_active')
#         # branchDays_ids = branchDays.values_list('id',flat=True)# ids of days
#         # branchDaysSlots = TempBranchDaySlot.objects.filter(branch_day_id__in =branchDays_ids).values('slot_id','slot__name','max_pt')
#         # for bd in branchDays : 
#         #     bd["day_name"]=getDayName(bd["day"].weekday())
#         #     bd["slots"]=branchDaysSlots.filter(branch_day_id=bd["id"])
#         context={
#             "branch_name":Branch.objects.get(id=branch_id).name,
#             "hourSlots":hourSlots,
#             "branchDays":branchDays,
#             "branch_id":branch_id,
#             'activePage':'Branches',
#         }
#         #return Response(context,status=status.HTTP_200_OK)
#         return render(request,"Clinic/clmainApp/branch_temp_schedule.html",context)    

#     @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.change_fixedworktimes_branches'), login_url='/auth/login/'))        
#     def post(self,request,branch_id):
#         request.data._mutable = True
#         data = request.data
#         data.update({"created_by":request.user.id,"branch":branch_id})
#         serializer= TempBranchDaySerializer(data=data)
#         if serializer.is_valid():
#             serializer.save()
#             return Response(status=status.HTTP_201_CREATED)
#         else :return Response(serializer.errors,status=status.HTTP_400_BAD_REQUEST)

# class TempDaySlotsApi(APIView):
#     @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.change_fixedworktimes_branches'), login_url='/auth/login/'))
#     def get(self,request,day_id): 
#         branchDaysSlots = TempBranchDaySlot.objects.filter(branch_day_id =day_id).values('slot_id','max_pt')
#         slots_data = []
#         for slot in branchDaysSlots:
#             slot_data = {"slot_id":slot["slot_id"],"max_pt":slot["max_pt"]}
#             slots_data.append(slot_data)
#         return Response(slots_data,status=status.HTTP_200_OK)

#     @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.change_fixedworktimes_branches'), login_url='/auth/login/'))        
#     def post(self,request,day_id):
#         data = request.data
#         day_slots_json = data['day_slots'] 
#         day_slots = json.loads(day_slots_json)
#         tbd_slots=[]
#         for ds in day_slots:
#             tbd_slots.append(TempBranchDaySlot(branch_day_id=day_id,slot_id=ds["slot_id"],max_pt=ds["max_pt"]))
#         try :
#             TempBranchDaySlot(branch_day_id=day_id).delete()
#             TempBranchDaySlot.objects.bulk_create(tbd_slots)
#             return Response(status=status.HTTP_201_CREATED)
#         except Exception as err_msg: 
#             return Response(data =" حدث خطأ إضافة توقيتات اليوم \n {}".format(str(err_msg)),status=status.HTTP_400_BAD_REQUEST) 


# class ExcepDaySlotsApi(APIView):
#     @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.change_fixedworktimes_branches'), login_url='/auth/login/'))
#     def get(self,request,day_id): 
#         branchDaysSlots = BranchExptnDaySlot.objects.filter(branch_day_id =day_id).values('slot_id','max_pt')
#         slots_data = []
#         for slot in branchDaysSlots:
#             slot_data = {"slot_id":slot["slot_id"],"max_pt":slot["max_pt"]}
#             slots_data.append(slot_data)
#         return Response(slots_data,status=status.HTTP_200_OK)

#     @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.change_fixedworktimes_branches'), login_url='/auth/login/'))        
#     def post(self,request,day_id):
#         data = request.data
#         day_slots_json = data['day_slots'] 
#         day_slots = json.loads(day_slots_json)
#         tbd_slots=[]
#         for ds in day_slots:
#             tbd_slots.append(BranchExptnDaySlot(branch_day_id=day_id,slot_id=ds["slot_id"],max_pt=ds["max_pt"]))
#         try :
#             BranchExptnDaySlot(branch_day_id=day_id).delete()
#             BranchExptnDaySlot.objects.bulk_create(tbd_slots)
#             return Response(status=status.HTTP_201_CREATED)
#         except Exception as err_msg: 
#             return Response(data =" حدث خطأ إضافة توقيتات اليوم \n {}".format(str(err_msg)),status=status.HTTP_400_BAD_REQUEST) 

# class TempBranchDayApi(APIView):
#     def get_object(self,pk):
#         try:
#             return TempBranchDay.objects.get(pk=pk)
#         except TempBranchDay.DoesNotExist:
#             return None    
#     @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.change_cancelreason'), login_url='/auth/login/'))
#     def put(self,request,day_id):
#         #request.data._mutable = True
#         data=request.data
#         temp_day=self.get_object(day_id)
#         if temp_day :
#             #print(data)
#             #data["is_active"] = True if data["is_active"] == 'True' else False
#             serializer= TempBranchDaySerializer(temp_day,data=data,partial=True)
#             if serializer.is_valid():
#                 serializer.save()
#                 return Response(status=status.HTTP_200_OK)
#             else :return Response(serializer.errors,status=status.HTTP_400_BAD_REQUEST)
#         else : return Response(status=status.HTTP_404_NOT_FOUND)
#     @method_decorator(user_passes_test(lambda u: u.has_perm('screen.delete_PatientVisit'), login_url='/auth/login/'))
#     def delete(self,request,day_id):
#         obj=self.get_object(day_id)
#         if obj :
#             try:
#                 obj.delete()
#                 return Response(status=status.HTTP_204_NO_CONTENT)
#             except Exception as err_msg: 
#                     return Response(data ="{}".format(str(err_msg)),status=status.HTTP_405_METHOD_NOT_ALLOWED)
#         else : return Response(status=status.HTTP_404_NOT_FOUND)

# class BranchExceptionalDaysApi(APIView):
#     @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.change_fixedworktimes_branches'), login_url='/auth/login/'))
#     def get(self,request,branch_id): 
#         #branch=self.get_object(branch_id)
#         #if not branch : return redirect('clauthApp:home')
#         working_days = BranchDay.objects.filter(branch_id=branch_id).values('day__name','day__js_code')
#         hourSlots = HourSlot.objects.filter(is_active=True).values('id','name').order_by('order')
#         timezone_now_today = timezone.now().date()
#         branchDays = BranchExceptionalDay.objects.filter(branch_id = branch_id,day__gte=timezone_now_today).values('id','title','day','notes','is_working_day')
#         context={
#             "working_days":working_days,
#             "hourSlots":hourSlots,
#             "branchDays":branchDays,
#             'activePage':'BranchExceptionalDaysApi',
#         }
#         #return Response(context,status=status.HTTP_200_OK)
#         return render(request,"Clinic/clmainApp/branch_exceptional_days.html",context)  
    
#     @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.change_fixedworktimes_branches'), login_url='/auth/login/'))        
#     def post(self,request,branch_id):
#         request.data._mutable = True
#         data = request.data
#         data.update({"created_by":request.user.id,"branch":branch_id})
#         serializer= BranchExceptionalDaySerializer(data=data)
#         if serializer.is_valid():
#             serializer.save()
#             return Response(status=status.HTTP_201_CREATED)
#         else : return Response(serializer.errors,status=status.HTTP_400_BAD_REQUEST)

# class BranchExceptionalDayApi(APIView):
#     def get_object(self,pk):
#         try:
#             return BranchExceptionalDay.objects.get(pk=pk)
#         except BranchExceptionalDay.DoesNotExist:
#             return None    
#     @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.change_cancelreason'), login_url='/auth/login/'))
#     def put(self,request,day_id):
#         data=request.data
#         exp_day=self.get_object(day_id)
#         if exp_day :
#             serializer= BranchExceptionalDaySerializer(exp_day,data=data,partial=True)
#             if serializer.is_valid():
#                 serializer.save()
#                 return Response(status=status.HTTP_200_OK)
#             #     BranchExptnDaySlot.objects.filter(branch_day=exp_day).delete()
#             #     if serializer.data["is_working_day"] and "day_slots" not in data :
#             #         return Response("برجاء إدخال توقيتات العمل لليوم ",status=status.HTTP_400_BAD_REQUEST)
#             #     if serializer.data["is_working_day"] and "day_slots" in data :
#             #         try:
#             #             day_slots_json = data['day_slots']
#             #             day_slots = json.loads(day_slots_json)
#             #             ebd_slots=[]#Exceptional Branch Day
#             #             for ds in day_slots:
#             #                 ebd_id = serializer.data["id"]
#             #                 ebd_slots.append(BranchExptnDaySlot(branch_day_id=ebd_id,slot_id=ds["slot_id"],max_pt=ds["max_pt"]))
#             #             BranchExptnDaySlot.objects.bulk_create(ebd_slots)
#             #             return Response(status=status.HTTP_200_OK)
#             #         except Exception as err_msg: 
#             #             return Response(data ="تم تعديل بيانات اليوم بنجاح - حدث خطأ إضافة توقيتات اليوم \n {}".format(str(err_msg)),status=status.HTTP_400_BAD_REQUEST) 
#             # else :return Response(serializer.errors,status=status.HTTP_400_BAD_REQUEST)
#         else : return Response(status=status.HTTP_404_NOT_FOUND)

'''
        # branchDays_ids = branchDays.values_list('id',flat=True)# ids of days
        # branchDaysSlots = BranchExptnDaySlot.objects.filter(branch_day_id__in =branchDays_ids).values('slot_id','slot__name','max_pt')
        # for bd in branchDays : 
        #     bd["day_name"]=getDayName(bd["day"].weekday())
        #     bd["slots"]=branchDaysSlots.filter(branch_day_id=bd["id"])
#لو يوم شغل لازم يكون باعت slots 
            if serializer.data["is_working_day"] and "day_slots" not in data :
                return Response("برجاء إدخال توقيتات العمل لليوم ",status=status.HTTP_400_BAD_REQUEST)
            if serializer.data["is_working_day"] and "day_slots" in data :
                try:
                    day_slots_json = data['day_slots'] 
                    day_slots = json.loads(day_slots_json)
                    tbd_slots=[]
                    for ds in day_slots:
                        tbd_id = serializer.data["id"]#TempBranchDay
                        tbd_slots.append(BranchExptnDaySlot(branch_day_id=tbd_id,slot_id=ds["slot_id"],max_pt=ds["max_pt"]))
                    BranchExptnDaySlot.objects.bulk_create(tbd_slots)
                    return Response(status=status.HTTP_201_CREATED)
                except Exception as err_msg: 
                    return Response(data ="تم إضافة اليوم بنجاح - حدث خطأ إضافة توقيتات اليوم \n {}".format(str(err_msg)),status=status.HTTP_400_BAD_REQUEST) 
            if not serializer.data["is_working_day"]: return Response(status=status.HTTP_201_CREATED)
'''

# class BranchDoctorsApi(APIView):
#     @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.add_doctors_to_branch'), login_url='/auth/login/'))
#     def get(self,request,branch_id):
#         branch_doctors_ids =BranchDoctor.objects.filter(branch_id=branch_id).values_list('dr_id',flat=True)
#         return Response(branch_doctors_ids,status=status.HTTP_200_OK)
 
#     @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.add_doctors_to_branch'), login_url='/auth/login/'))
#     def post(self,request,branch_id):
#         data = request.data
#         selected_doctors = data.getlist('doctors[]')
#         branch_doctors = []
#         if selected_doctors :
#             for doctor in selected_doctors :
#                 branch_doctors.append({"dr":doctor ,"branch":branch_id })
#         serializedObj= BranchDoctorsSerializer(data=branch_doctors,many=True)
#         # if not clinicId : return Response(status=status.HTTP_400_BAD_REQUEST)
#         if serializedObj.is_valid():
#             BranchDoctor.objects.filter(branch_id=branch_id).delete()
#             serializedObj.save()
#             return Response(status=status.HTTP_201_CREATED)
#         else :return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)

# class BranchReceptionsApi(APIView):
#     @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.add_receptions_to_branch'), login_url='/auth/login/'))
#     def get(self,request,branch_id):
#         branch_receptions_ids =BranchReception.objects.filter(branch_id=branch_id).values_list('reception_id',flat=True)
#         return Response(branch_receptions_ids,status=status.HTTP_200_OK)
 
#     @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.add_receptions_to_branch'), login_url='/auth/login/'))
#     def post(self,request,branch_id):
#         data = request.data
#         selected_receptions = data.getlist('selected_receptions[]')
#         branch_receptions = []
#         if selected_receptions :
#             for reception in selected_receptions :
#                 branch_receptions.append({"reception":reception ,"branch":branch_id })
#         serializedObj= BranchReceptionsSerializer(data=branch_receptions,many=True)
#         # if not clinicId : return Response(status=status.HTTP_400_BAD_REQUEST)
#         if serializedObj.is_valid():
#             BranchReception.objects.filter(branch_id=branch_id).delete()
#             serializedObj.save()
#             return Response(status=status.HTTP_201_CREATED)
#         else :return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)